// Jehard (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[]) {

	char fname[FILENAME_MAX];
	int i,d;
	char id1[] = { 0xf3, 0x31, 0x00, 0xc0, 0x97, 0xd3, 0x51, 0x3e };
	char id2[] = "Jehard  XTALSOFT (c)1987.7";

	// Disk A
	struct fpos md1[] = {
		{ 0x3d, 0x05, 0x0600 },	// 
		{ 0x3d, 0x0b, 0x0300 },	// 
		{ 0x3d, 0x0e, 0x0200 },	// 
		{ 0x3d, 0x10, 0x0200 },	// 
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// Disk B
	struct fpos md2[] = {
		{ 0x3f, 0x10, 0x0800 },	//
		{ 0x40, 0x08, 0x0300 },	//
		{ 0x40, 0x0b, 0x0300 },	//
		{ 0x40, 0x0e, 0x0300 },	//
		{ 0x41, 0x01, 0x0200 },	//
		{ 0x41, 0x03, 0x0200 },	//
		{ 0x41, 0x05, 0x0200 },	//
		{ 0x41, 0x07, 0x0300 },	//
		{ 0x41, 0x0c, 0x0200 },	//
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};


	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x010);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(buff,id1,sizeof(id1))) {
			printf("Disk AF܂.\n");
			fcut("PROG",  0x04, 0x02, 0x00, 0x01, 0x01, 0x0000, 0x5000);
			fcut("VOICE", 0x3d, 0x1e, 0x01, 0x01, 0x01, 0x0000, 0x0400);
			// ȃf[^̐؂o
			for (i=0; md1[i].sec; i++) {
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
			continue;
		}
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(buff,id2,sizeof(id2))) {
			printf("Disk BF܂.\n");
			// ȃf[^̐؂o
			for (i=0; md2[i].sec; i++) {
				sprintf(fname,"MUS%02d",i+4);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
			continue;
		}
	}
	return 0;
}

